package cn.ibizlab.humanresource.core.base.service;

import java.io.Serializable;
import java.sql.Timestamp;
import java.util.ArrayList;
import java.util.List;
import java.util.Map;
import java.util.HashMap;
import java.util.Collection;
import java.math.BigInteger;

import org.springframework.data.domain.Page;
import org.springframework.data.domain.Pageable;
import com.alibaba.fastjson.JSONObject;
import org.springframework.cache.annotation.CacheEvict;

import cn.ibizlab.humanresource.core.base.domain.HROMHierarchyPurposeRef;
import cn.ibizlab.humanresource.core.base.filter.HROMHierarchyPurposeRefSearchContext;


import com.baomidou.mybatisplus.extension.service.IService;

/**
 * 实体[HROMHierarchyPurposeRef] 服务对象接口
 */
public interface IHROMHierarchyPurposeRefService extends IService<HROMHierarchyPurposeRef>{

    boolean create(HROMHierarchyPurposeRef et) ;
    void createBatch(List<HROMHierarchyPurposeRef> list) ;
    boolean update(HROMHierarchyPurposeRef et) ;
    void updateBatch(List<HROMHierarchyPurposeRef> list) ;
    boolean remove(String key) ;
    void removeBatch(Collection<String> idList) ;
    HROMHierarchyPurposeRef get(String key) ;
    HROMHierarchyPurposeRef getDraft(HROMHierarchyPurposeRef et) ;
    boolean checkKey(HROMHierarchyPurposeRef et) ;
    boolean save(HROMHierarchyPurposeRef et) ;
    void saveBatch(List<HROMHierarchyPurposeRef> list) ;
    Page<HROMHierarchyPurposeRef> searchDefault(HROMHierarchyPurposeRefSearchContext context) ;
    List<HROMHierarchyPurposeRef> selectByOmhierarchycatid(String omhierarchycatid) ;
    void removeByOmhierarchycatid(String omhierarchycatid) ;
    List<HROMHierarchyPurposeRef> selectByOmhierarchypurposeid(String omhierarchypurposeid) ;
    void removeByOmhierarchypurposeid(String omhierarchypurposeid) ;
    /**
     *自定义查询SQL
     * @param sql  select * from table where id =#{et.param}
     * @param param 参数列表  param.put("param","1");
     * @return select * from table where id = '1'
     */
    List<JSONObject> select(String sql, Map param);
    /**
     *自定义SQL
     * @param sql  update table  set name ='test' where id =#{et.param}
     * @param param 参数列表  param.put("param","1");
     * @return     update table  set name ='test' where id = '1'
     */
    boolean execute(String sql, Map param);

    List<HROMHierarchyPurposeRef> getHromhierarchypurposerefByIds(List<String> ids) ;
    List<HROMHierarchyPurposeRef> getHromhierarchypurposerefByEntities(List<HROMHierarchyPurposeRef> entities) ;
}


